



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>图解Netty之Pipeline、channel、Context之间的数据流向。</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">图解Netty之Pipeline、channel、Context之间的数据流向。</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 22:38:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong> 声明：本文为原创博文，禁止转载。</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 以下所绘制图形均基于Netty4.0.28版本。</strong></p>
<p><strong>一、connect（outbound类型事件）</strong></p>
<p><strong> &nbsp;当用户调用channel的connect时，会发起一个outbound类型的事件，该事件将在pipeline中传递（pipeline.connect）,首先由tail handler处理，该handler只是将事件透传给下一个outbound类型的用户Handler(如果有)，事件依次传递下去，直到传递到head handler，该handler会调用unsafe.connect()向eventloop(nio的selector)注册一个读事件。&nbsp;</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/592743/201611/592743-20161120163422951-1947844045.png"></strong></p>
<p><strong>二、connect成功之后数据流图（inbound类型事件）</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp; 当用户发起一个connect请求后，当连接可用时，eventloop（底层使用nio的selector）会引发一个ChannelActive事件，该事件最先有unsafe捕获，之后会调用pipeline.fireChannelActive()将该事件在pipeline中传播，紧接着会根据inbound类型事件的传递方式在各个handler和context之间进行链式传递。其中，有一个比较关注的地方是，在channelActive事件触发的时候，如果channel被设置成autoRead，那么此时还会调用channel.read()方法，该方法并不是真正的从channel读取数据，而是向eventloop注册读事件（因为一个channel在向eventloop中注册时，默认不注册任何事件），关于channel.read的过程可以看下文的另一张图。</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/592743/201611/592743-20161120160116435-1999384267.png"></p>
<p><strong>三、channel.read事件流图（outbound类型事件）</strong></p>
<p><strong>&nbsp; 当用户调用channel.read()后，会发起一个outbound类型的事件，该事件最先会由pipeline中tail handler处理，该handler只是将该事件透传给前面一个outbound类型的用户handler(如果有的话)，这样依次继续向前传递，直到传递到head handler，该handler会调用unsafe.read()向eventloop注册读事件（也就是向nio的selector上添加读事件）</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/592743/201611/592743-20161120161518967-2088423096.png"></p>
<p><strong>四、channel.write（outbound类型事件）</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp;与channel.read()类型，wirte也是一个outbound类型事件，该事件最先会由pipeline中的tail handler透传给前面的一个outbound类型的用户handler(如果有的话)，这样依次传递，直到传递给head handler，该handler会调用unsafe.write()方法，这里的wirte并不会执行真正的发送，而是将要发送的数据缓存起来，直到调用flush时，这些数据才会执行真正的网络io。&nbsp;</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/592743/201611/592743-20161120162200513-417453716.png"></p>
<p><strong>&nbsp;五、flush（outbound类型事件）</strong></p>
<p><strong>&nbsp; &nbsp; &nbsp;如前文所示，flush也是一个outbound类型的事件，与wirte不同，flush会执行真正的网络io操作。</strong></p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/592743/201611/592743-20161120163938123-1381703140.png"></p>
<p><strong>六、当channel有数据可读时（inbound类型事件）</strong></p>
<p>当eventloop层检测到网络层有数据可读时（nio的selector返回相应的seleciontKeys），该事件会首先传递给unsafe，紧接着会调用pipeline.fireChannelRead()，将事件开始在pipeline中传递，该事件最先会有head handler处理（head.fireChannelRead()），该handler直接将事件透传给下一个inbound类型的用户handler(如果有的话)，该事件依次向下传递，直到传递到tail handler。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/592743/201611/592743-20161120162610295-1244898670.png"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyxx28r.html">常用js功能函数集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rxk490.html">android 模拟2048</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jz74w8.html">JS冒泡排序（div）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pwwn48.html">adb 无法启动问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qndmn28.html">Unity 难点目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdg1wvq.html">Knockoutjs  实践入门 &lpar;1&rpar; 属性绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzgd6q.html">ViewController respondsToSelector&colon;&rsqb;&colon; message sent to deallocated instance</a>
		</li>
						<li><a href="https://www.batexi.com/a/495kp1v9.html">spring mvc拦截器和&amp;lt&semi;mvc&colon;annotation-driven &sol;&amp;gt&semi;的详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11o5g8.html">【北京站】详解Visual Studio 2013：开发iOS及android应用！现场图集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ym6d9.html">NAT学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xorzv8.html">Tuple初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwlpd8.html">json在PHP中应用技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwjol8.html">文本框、文本编辑框、按钮&mdash;&mdash;axure线框图部件库介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoydrnq.html">LoadTest中内存和线程Troubleshooting实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj0mk38.html">vim保存时提示&colon; 无法打开并写入文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pgv138.html">Go笔记-指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zvxg59.html">c&plus;&plus; 输出精度</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1pmrgq.html">jquery 第三章</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk0wkz8.html">Laravel日常使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25g3zlq.html">left join</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7mzkxq.html">IOS 网络浅析－（十一 三方 AFNetworking3&period;0简介）</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gmj2l9.html">论Pair的重要性</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mnlkoq.html">mysql的缓冲查询和非缓冲查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wmzvq.html">java 线程池&mdash;&mdash;异步任务</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gm4779.html">jedisLock&mdash;redis分布式锁实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8okgre9.html">&lbrack;No00009A&rsqb;JsonToObject json与类互转</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8okgmx9.html">ns3 print 丢包内容的两种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93x71r9.html">解决 node-gyp rebuild 卡住 的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j0vxwq.html">&lbrack;LeetCode&rsqb; Count Univalue Subtrees 计数相同值子树的个数</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k1k7r9.html">&lbrack;LeetCode&rsqb; Reverse Linked List II 倒置链表之二</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
